// Generated by CoffeeScript 2.2.3
(function() {
  var $, Health, Http, echo;

  $ = require('bling');

  Http = require('http');

  ({echo} = require('../common'));

  $.extend(module.exports, Health = {
    defaultPath: "/",
    defaultInterval: 10000,
    defaultStatus: 200,
    defaultText: "",
    defaultTimeout: 3000,
    monitor: function(group, path, interval, status, text, timeout) {
      path = String(path != null ? path : Health.defaultPath);
      if (!(path.length > 0)) {
        return new Error(`Invalid path: ${path}`);
      }
      interval = parseInt(interval != null ? interval : Health.defaultInterval, 10);
      if (!(isFinite(interval) && !isNaN(interval))) {
        return new Error(`Invalid interval: ${interval}.`);
      }
      status = parseInt(status != null ? status : Health.defaultStatus, 10);
      if (!(isFinite(status) && !isNaN(status))) {
        return new Error(`Invalid status: ${status}.`);
      }
      text = String(text != null ? text : Health.defaultText);
      // if text.length > 0 then return new Error("Invalid text: #{text}.")
      timeout = parseInt(timeout != null ? timeout : Health.defaultTimeout);
      if (!(isFinite(timeout) && !isNaN(timeout))) {
        return new Error(`Invalid timeout: ${timeout}.`);
      }
      group.monitors || (group.monitors = Object.create(null));
      if (path in group.monitors) {
        return new Error("Group is already monitored.");
      }
      group.monitors[path] = $.interval(interval, function() {
        var i, len, proc, results;
        results = [];
        for (i = 0, len = group.length; i < len; i++) {
          proc = group[i];
          if (proc.expected) {
            results.push((function(group, path, interval, status, text, timeout, proc) {
              var countdown, fail, req;
              countdown = null;
              if (proc.enabled && !proc.started) {
                proc.healthy = false;
                return;
              }
              proc.healthy = void 0;
              fail = function(msg) {
                var ref, ref1;
                clearTimeout(countdown);
                echo(`Health check failed (${msg}), pid: ${((ref = proc.proc) != null ? ref.pid : void 0)} port: ${proc.port}`);
                proc.healthy = false;
                return (ref1 = proc.proc) != null ? ref1.kill() : void 0;
              };
              if (timeout > 0) {
                countdown = setTimeout((() => {
                  return fail('timeout');
                }), timeout);
              }
              req = Http.get({
                host: "127.0.0.1",
                port: proc.port,
                path: path
              }, function(res) {
                var buffer;
                clearTimeout(countdown);
                if (status !== 0 && res.statusCode !== status) {
                  return fail("bad status: " + res.statusCode);
                }
                if (text.length > 0) {
                  buffer = "";
                  res.setEncoding('utf8');
                  res.on('data', function(data) {
                    return buffer += data;
                  });
                  res.on('end', function() {
                    if (!(buffer.indexOf(text) > -1)) {
                      return fail("text not found: " + text);
                    }
                  });
                }
                res.on('error', function(err) {
                  return fail("response error: " + String(err));
                });
                return proc.healthy = true;
              });
              return req.on('error', function(err) {
                return fail("request error: " + String(err));
              });
            })(group, path, interval, status, text, timeout, proc));
          }
        }
        return results;
      });
      Object.assign(group.monitors[path], {interval, status, text, timeout});
      return true;
    },
    unmonitor: function(group, path) {
      var check, ref;
      if (!('monitors' in group)) {
        return false;
      }
      if ((path != null) && !(path in group.monitors)) {
        return false;
      }
      if (path != null) {
        group.monitors[path].cancel();
      } else {
        ref = group.monitors;
        for (path in ref) {
          check = ref[path];
          check.cancel();
          delete group.monitors[path];
        }
      }
      return true;
    },
    pause: function(group, path) {
      var check, ref;
      if (!('monitors' in group)) {
        return false;
      }
      if ((path != null) && !(path in group.monitors)) {
        return false;
      }
      if (path != null) {
        group.monitors[path].pause();
        group.monitors[path].paused = true;
      } else {
        ref = group.monitors;
        for (path in ref) {
          check = ref[path];
          check.pause();
        }
      }
      return true;
    },
    resume: function(group, path) {
      var check, ref;
      if (!('monitors' in group)) {
        return false;
      }
      if ((path != null) && !(path in group.monitors)) {
        return false;
      }
      if (path != null) {
        group.monitors[path].resume();
        group.monitors[path].paused = false;
      } else {
        ref = group.monitors;
        for (path in ref) {
          check = ref[path];
          check.resume();
        }
      }
      return true;
    },
    toConfig: function() {
      var buf;
      buf = "";
      Groups.forEach(function(group) {
        var interval, mon, path, ref, results, status, text, timeout;
        if (group.monitors == null) {
          return;
        }
        ref = group.monitors;
        results = [];
        for (path in ref) {
          mon = ref[path];
          ({interval, status, text, timeout} = mon);
          results.push(buf += `health --group ${group.name} --path "${path}"` + (status > 0 ? ` --status ${status}` : "") + (interval > 0 ? ` --interval ${interval}` : "") + (text.length > 0 ? ` --contains "${text}"` : "") + (timeout > 0 ? ` --timeout ${timeout}` : void 0));
        }
        return results;
      });
      return buf;
    }
  });

}).call(this);
